modnum_util=lib(MODNUM+'/macros/build_util/');
u=mopen(MODNUM+"/loader.sce","w");
write_header(u,'generate_loader.sce');
libs=['build_util';'find_file';'misc';'scicos_util';'signal';'scicos_overload'];
rep_lib='/macros/'+libs;
lib_name='modnum_'+libs;
txt=write_inf_lib(u,rep_lib,lib_name,1);
pal=['Communication';'Filter';'NonLinear';'Pll';'Sinks';'Sources';'Tools';'Old'];
rep_pal='/macros/scicos_blocks/'+pal;
pal_name=['com';'filter';'nonlinear';'pll';'sinks';'sources';'tools';'old'];
pal_title='modnum_'+pal;
lib_name='modnum_'+pal_name+'_pal';
fprintf(u,"%s\n",'//Load modnum scicos_blocks library');
txt=write_inf_lib(u,rep_pal,lib_name,0);
txt=write_inf_pal(u,rep_pal+'.cosf',pal_title);
path='/routines/modnum_lib';
files=basename(listfiles(MODNUM+path+'/*.c'));
libname="libmodnum_lib";
txt=write_inf_rout_lib(u,libname,path,files,0);
scifunc=["genint";"genrayl";"upsmpl";"downsmpl";"modpsk";"demodpsk";
         "modqam";"demodqam";"gengold";"genpn";
         "spread";"despread";"nfilter";"awgn";"intsym";
         "autocorr";"data2sig";"sig2data"];
intname="intmodnum_lib";
txt=write_addinter_line(u,libname,path,intname,scifunc);
path=['/routines/scicos/communication';'/routines/scicos/filter';'/routines/scicos/nonlinear';'/routines/scicos/old';'/routines/scicos/other';'/routines/scicos/pll';'/routines/scicos/sinks';'/routines/scicos/sources';'/routines/scicos/tools'];
libname=["libmodnum_comm_c";"libmodnum_filt_c";"libmodnum_nlin_c";"libmodnum_old_c";"libmodnum_oth_c";"libmodnum_pll_c";"libmodnum_sink_c";"libmodnum_src_c";"libmodnum_tool_c"];
for i=1:size(libname,1)
  files_c=basename(listfiles(MODNUM+path(i)+'/*.c'));
  txt=write_inf_rout_lib(u,libname(i),path(i),files_c,1);
end
path=['/routines/scicos/old'];
libname=["libmodnum_old_f"];
files_f=basename(listfiles(MODNUM+path+'/*.f'));
write_inf_rout_lib(u,libname,path,files_f,2);
txt=write_inf_doc(u);
txt=write_inf_contrib(u);
mclose(u);
txt=mgetl('loader.sce');
mputl(txt,'.scilab');
